#lang racket/base

; elf-constants.rkt

; Elf constant values

(provide (all-defined-out))

(define elf-magic (bytes-append (bytes 127)
                                #"ELF"))

(define elf-class-32 1)
(define elf-class-64 2)
(define elf-2cmpl-lsb 1)
(define elf-2cmpl-msb 2)

(define elf-abi-sysv 0)
(define elf-abi-hpux 1)
(define elf-abi-netbsd 2)
(define elf-abi-gnu 3)
(define elf-abi-solaris 6)
(define elf-abi-aix 7)
(define elf-abi-irix 8)
(define elf-abi-freebsd 9)
(define elf-abi-tru64 10)
(define elf-abi-modesto 11)
(define elf-abi-openbsd 12)
(define elf-abi-arm-aeabi 64)
(define elf-abi-arm 97)
(define elf-abi-standalone 255)

(define elf-type-reloc 1)
(define elf-type-exec 2)
(define elf-type-dyn 3)
(define elf-type-core 4)

; elf architectures
(define elf-arch-m32 1) ; LIST INCOMPLETE
(define elf-arch-sparc 2)
(define elf-arch-386 3)
(define elf-arch-m68k 4)
(define elf-arch-m88k 5)
(define elf-arch-860 5)
(define elf-arch-mips 8)
(define elf-arch-s370 9)
(define elf-arch-mips-rs3-le 10)
(define elf-arch-parsic 15)
(define elf-arch-vpp500 17)
(define elf-arch-sparc32plus 18)
(define elf-arch-intel960 19)
(define elf-arch-ppc 20)
(define elf-arch-ppc64 21)
(define elf-arch-s390 22)
(define elf-arch-v800 36)
(define elf-arch-fr20 37)
(define elf-arch-rh32 38)
(define elf-arch-rce 39)
(define elf-arch-arm 40)
(define elf-arch-fake-alpha 41)
(define elf-arch-sh 42)
(define elf-arch-sparcv9 43)
(define elf-arch-tricore 44)
(define elf-arch-arc 45)
(define elf-arch-h800-300 46)
(define elf-arch-h800-300h 47)
(define elf-arch-h8s 48)
(define elf-arch-h8-500 49)
(define elf-arch-ia-64 50)
(define elf-arch-mipsx 51)
(define elf-arch-coldfire 52)
(define elf-arch-68hc12 53)
(define elf-arch-mma 54)
(define elf-arch-pcp 55)
(define elf-arch-ncpu 56)
(define elf-arch-ndr1 57)
(define elf-arch-starcore 58)
(define elf-arch-me16 59)
(define elf-arch-st100 60)
(define elf-arch-tinyj 61)
(define elf-arch-x8664 62)

(define elf-arch-xtensa 94)

; section types
(define elf-section-type-null 0)
(define elf-section-header-type-progdata 1)
(define elf-section-header-type-symtab 2)
(define elf-section-header-type-strtab 3)
(define elf-section-header-type-reloca 4)
(define elf-section-header-type-hash 5)
(define elf-section-header-type-dynamic 6)
(define elf-section-header-type-note 7)
(define elf-section-header-type-nobits 8)
(define elf-section-header-type-reloc 9)
(define elf-section-header-type-shlib 10)
(define elf-section-header-type-dynsym 11)
(define elf-section-header-type-initarray 14)
(define elf-section-header-type-fintarray 15)
(define elf-section-header-type-preinitarray 16)
(define elf-section-header-type-group 17)
(define elf-section-header-type-symtabshindex 18)

; section flags
(define elf-section-header-flag-write 1)
(define elf-section-header-flag-alloc 2)
(define elf-section-header-flag-exec 4)
(define elf-section-header-flag-merge 8)
(define elf-section-header-flag-strings 16)
(define elf-section-header-flag-infolink 32)

; program types
(define elf-program-header-type-load 1)
(define elf-program-header-type-dynamic 2)
(define elf-program-header-type-interp 3)
(define elf-program-header-type-note 4)
(define elf-program-header-type-shlib 5)
